from fastapi.routing import APIRouter
from fastapi.requests import Request

from api_validations.validations_request import (
    InsertBuildLivingSpace,
    UpdateBuildLivingSpace,
    PatchRecord,
    ListOptions,
)
from api_services.redis.auth_actions.token import parse_token_object_to_dict

build_living_space = APIRouter(prefix="/building/living_space", tags=["Living Space"])
build_living_space.include_router(build_living_space, include_in_schema=True)


@build_living_space.post(
    path="/list", summary="List Active/Delete/Confirm Build Living Space"
)
def building_living_space_list(request: Request, list_options: ListOptions):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(list_options=list_options, token_dict=token_dict)


@build_living_space.post(
    path="/create", summary="Create Build Living Space with given auth levels"
)
def building_living_space_create(request: Request, data: InsertBuildLivingSpace):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(data=data, token_dict=token_dict)


@build_living_space.post(
    path="/update/{build_uu_id}",
    summary="Update Build Living Space with given auth levels",
)
def building_living_space_update(
    request: Request, build_uu_id: str, data: UpdateBuildLivingSpace
):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(
        data=data, build_uu_id=build_uu_id, token_dict=token_dict
    )


@build_living_space.patch(
    path="/patch/{build_uu_id}",
    summary="Update Build Living Space with given auth levels",
)
def building_living_space_patch(request: Request, build_uu_id: str, data: PatchRecord):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(
        data=data, build_uu_id=build_uu_id, token_dict=token_dict
    )
